import gi, time
gi.require_version('Peas', '1.0')
from gi.repository import GObject
from gi.repository import Peas

class EchoWorld(GObject.Object, Peas.Activatable):
    __gtype_name__ = 'echoworld'

    object = GObject.Property(type=GObject.Object)
    def __init__(self):
        pass
    def do_activate(self):
        API = self.object
        self.setKeybinding('d')
        self.speak('Echo World loaded, key bound to d')
    def do_deactivate(self):
        API = self.object
        self.setKeybinding(None)
        self.speak('Echo World unloaded')
    def do_update_state(self):
        API = self.object
    def setKeybinding(self, keybinding):
        API = self.object
        if keybinding == None:
            API.app.getAPIHelper().unregisterShortcut(self.keybinding)
        else:
            keybinding = keybinding = API.app.getAPIHelper().registerShortcut(self.echo, keybinding, 'echo')
        self.keybinding = keybinding
    def echo(self, script, inputEvent):
        API = self.object
        self.speak('Echo World shortcut pressed')
    def speak(self, Message):
        API = self.object
        try:
            API.app.getDynamicApiManager().getAPI('OrcaState').activeScript.presentMessage(Message, resetStyles=False)
        except:
            pass
